function love.load()
    love.window.setMode(800, 600, { fullscreen = false })
    love.mouse.setVisible(false)
    love.mouse.setRelativeMode(true)
    love.window.setTitle("Gnop")
    love.graphics.setNewFont(24)
    --
    x = 394
    y = 260
    speedint = 120
    speedbluex = speedint
    speedredx = -speedint
    math.randomseed(os.time())
    speedbluey = math.random(-speedint,speedint)
    speedredy = math.random(-speedint,speedint)
    blueballx = 18
    bluebally = 292
    redballx = 782
    redbally = 292
    start = true
    go = true 
    time = 0
    over = false
    fullscreen = false
end

function love.keypressed(key)
    if key == "escape" then
        love.event.push("quit")
    end
    if key == "f" then
        if fullscreen then
            fullscreen = false
            love.window.setMode(800, 600, {fullscreen=fullscreen, fullscreentype="exclusive"})
        else
            fullscreen = true
            love.window.setMode(800, 600, {fullscreen=fullscreen, fullscreentype="exclusive"})
        end
    end
    if key == "space" and start then
        start = false
        go = true
    elseif key == "space" and go then
        go = false
    elseif key == "space" and over then
        x = 394
        y = 260
        speedint = 120
        speedbluex = speedint
        speedredx = -speedint
        math.randomseed(os.time())
        speedbluey = math.random(-speedint,speedint)
        speedredy = math.random(-speedint,speedint)
        blueballx = 18
        bluebally = 292
        redballx = 782
        redbally = 292
        start = true
        go = true
        time = 0
        over = false
    end
end

function love.update(dt)
    if not start and not over and not go then
        time = time + dt
        if math.ceil(time) % 10 == 0 then
            if speedbluex > 0 then
                speedbluex = speedbluex + (50 * dt)
            else
                speedbluex = speedbluex - (50 * dt)
            end
            if speedredx > 0 then
                speedredx = speedredx + (50 * dt)
            else
                speedredx = speedredx - (50 * dt)
            end
            speedint = speedint + (1 * dt)
        end
        if blueballx < 10 then
            blueballx = 10
            speedbluex = -speedbluex
        elseif blueballx > 400 then
            over = true
        end
        if bluebally < 10 then
            bluebally = 10
            speedbluey = -speedbluey
        elseif bluebally > 590 then
            bluebally = 590
            speedbluey = -speedbluey
        end
        if redballx > 790 then
            redballx = 790
            speedredx = -speedredx
        elseif redballx < 400 then
            over = true
        end
        if redbally < 10 then
            redbally = 10
            speedredy = -speedredy
        elseif redbally > 590 then
            redbally = 590
            speedredy = -speedredy
        end
        blueballx = blueballx + (speedbluex * dt)
        bluebally = bluebally + (speedbluey * dt)
        if math.ceil(time) > 4 then
            redballx = redballx + (speedredx * dt)
            redbally = redbally + (speedredy * dt)
        end
    end
    if CheckCollision(blueballx - 8, bluebally - 8, 16, 16, x, y, 12, 60) then
        blueballx = x - 8
        speedbluey = math.random(-speedint, speedint)
        speedbluex = -speedbluex
    end       
    if CheckCollision(redballx - 8, redbally - 8, 16, 16, x, y, 12, 60) then
        redballx = x + 20 
        speedredy = math.random(-speedint, speedint)
        speedredx = -speedredx
    end       
    _, mousey = love.mouse.getPosition()
    if mousey > 540 then
        mousey = 540
    end
    if mousey < 0 then
        mousey = 0
    end
    y = mousey
end

function love.draw()
    if not start and not over then
        love.graphics.setColor(100, 30, 30)
        love.graphics.rectangle("fill", 0, 0, 399, 600)
        love.graphics.setColor(30, 30, 100)
        love.graphics.rectangle("fill", 401, 0, 800, 600)
        love.graphics.setColor(100, 255, 100)
        love.graphics.line(x + 6, 0, 400, 600)
        love.graphics.setColor(200, 200, 200)
        love.graphics.rectangle("fill", x, y, 12, 60)
        love.graphics.setColor(100, 30, 30)
        love.graphics.circle("fill", redballx, redbally, 8)
        love.graphics.setColor(30, 30, 100)
        love.graphics.circle("fill", blueballx, bluebally, 8)
        love.graphics.setColor(100, 255, 100)
        love.graphics.circle("line", redballx, redbally, 8)
        love.graphics.circle("line", blueballx, bluebally, 8)
        love.graphics.setColor(255, 255, 255)
        love.graphics.print(math.ceil(time), 700, 20)
    end
    if go then
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("Press Space to start.", 280, 440)
    end
    if start then
        love.graphics.setColor(255, 100, 100)
        love.graphics.print("gnop!", 280, 300)
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("by O. Bahri Gordebak", 300, 330)
        love.graphics.print("Press Escape to quit", 280, 470)
        love.graphics.print("Press F to toggle fullscreen", 280, 500)
    end
    if over then
        love.graphics.setColor(255, 255, 255)
        love.graphics.print("You survived for "..math.ceil(time).." seconds.", 300, 400)
        if math.ceil(time) > 50 and math.ceil(time) <= 80 then
            love.graphics.print("Nice job!", 300, 430)
        elseif math.ceil(time) > 80 and math.ceil(time) <= 100 then
            love.graphics.print("You're a great player!", 300, 430)
        elseif math.ceil(time) > 100 then
            love.graphics.print("Truly wonderful!", 300, 430)
        end
        love.graphics.print("Press Space to play again.\nPress Escape to quit.", 300, 460)
    end
end

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end
